local L = AceLibrary("AceLocale-2.2"):new("GrindStatus")
local locked = true
GrindStatus = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceModuleCore-2.0")
local quixote = AceLibrary("Quixote-1.0")
local tablet = AceLibrary("Tablet-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local BR = AceLibrary("Babble-Race-2.2")
local PT = AceLibrary("PeriodicTable-2.0")
local deformat = AceLibrary("Deformat-2.0")
local futext = "GrindStatus"
local lootfaction
local grouporder = {}
local qualitycolors = {
	[0] = "|cff9d9d9d",
	[1] = "|cffffffff",
	[2] = "|cff1eff00",
	[3] = "|cff0070dd",
	[4] = "|cffa335ee",
	[5] = "|cffff8000" }
GrindStatus:RegisterDB("GrindStatusDB")
local options = {
	name = L["GrindStatus"],
	desc = L["GrindStatus"],
	type = "group",
	args = {
		header7 = {
			type = "header",
			order = 7999,
		},
		autoswitch = {
			name = L["Autoswitch"],
			desc = L["Automatically change watched faction on rep gains."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.autoswitch end,
			set = function(v) GrindStatus.db.profile.autoswitch=v if v then GrindStatus:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE") else GrindStatus:UnregisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE") end end,
			order = 8000,
		},
		header8 = {
			type = "header",
			order = 8999,
		},
		showname = {
			name = L["Display Name"]..L["(rep bar)"],
			desc = L["Display faction name in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displayname end,
			set = function(v) GrindStatus.db.profile.displayname=v GrindStatus:UpdateText() end,
			order = 9000,
		},
		showpercent = {
			name = L["Display Percent"]..L["(rep bar)"],
			desc = L["Display progress percent in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displaypercent end,
			set = function(v) GrindStatus.db.profile.displaypercent=v GrindStatus:UpdateText() end,
			order = 9002,
		},
		showtotalrep = {
			name = L["Display Total Rep"]..L["(rep bar)"],
			desc = L["Display total rep progress in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displayabsoluterep end,
			set = function(v) GrindStatus.db.profile.displayabsoluterep=v GrindStatus:UpdateText() end,
			order = 9004,
		},
		shownamefu = {
			name = L["Display Name"]..L["(fubar)"],
			desc = L["Display faction name in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displaynamefu end,
			set = function(v) GrindStatus.db.profile.displaynamefu=v GrindStatus:UpdateText() end,
			order = 9006,
		},
		showpercentfu = {
			name = L["Display Percent"]..L["(fubar)"],
			desc = L["Display progress percent in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displaypercentfu end,
			set = function(v) GrindStatus.db.profile.displaypercentfu=v GrindStatus:UpdateText() end,
			order = 9008,
		},
		showtotalrepfu = {
			name = L["Display Total Rep"]..L["(fubar)"],
			desc = L["Display total rep progress in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displayabsoluterepfu end,
			set = function(v) GrindStatus.db.profile.displayabsoluterepfu=v GrindStatus:UpdateText() end,
			order = 9010,
		},
		header9 = {
			type = "header",
			order = 9999,
		},
		hideoverlay = {
			name = L["Hide Overlay"],
			desc = L["Hide the rep bar overlay"],
			type = "toggle",
			get = function() return GrindStatus.db.profile.hideoverlay end,
			set = function(v) GrindStatus.db.profile.hideoverlay=v if v then GrindStatusFrame:Hide() else GrindStatusFrame:Show() end GrindStatus:UpdateText() end,
			order = 10000,
		},
		lock = {
			name = L["Lock"],
			desc = L["Toggle Locking"],
			type = "toggle",
			get = function() return locked end,
			set = function(v) locked=v end,
			order = 10002,
		},
	}
}
GrindStatus.Options = {
	name = L["GrindStatus"],
	desc = L["GrindStatus"],
	type = "group",
	args = {
		header6 = {
			type = "header",
			order = 6999,
		},
		alphabetical = {
			name = L["Alphabetical"],
			desc = L["Alphabetical"],
			type = "group",
			order = 7000,
			args = {}
		},
		header7 = {
			type = "header",
			order = 7999,
		},
		autoswitch = {
			name = L["Autoswitch"],
			desc = L["Automatically change watched faction on rep gains."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.autoswitch end,
			set = function(v) GrindStatus.db.profile.autoswitch=v if v then GrindStatus:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE") else GrindStatus:UnregisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE") end end,
			order = 8000,
		},
		header8 = {
			type = "header",
			order = 8999,
		},
		showname = {
			name = L["Display Name"]..L["(rep bar)"],
			desc = L["Display faction name in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displayname end,
			set = function(v) GrindStatus.db.profile.displayname=v GrindStatus:UpdateText() end,
			order = 9000,
		},
		showpercent = {
			name = L["Display Percent"]..L["(rep bar)"],
			desc = L["Display progress percent in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displaypercent end,
			set = function(v) GrindStatus.db.profile.displaypercent=v GrindStatus:UpdateText() end,
			order = 9002,
		},
		showtotalrep = {
			name = L["Display Total Rep"]..L["(rep bar)"],
			desc = L["Display total rep progress in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displayabsoluterep end,
			set = function(v) GrindStatus.db.profile.displayabsoluterep=v GrindStatus:UpdateText() end,
			order = 9004,
		},
		shownamefu = {
			name = L["Display Name"]..L["(fubar)"],
			desc = L["Display faction name in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displaynamefu end,
			set = function(v) GrindStatus.db.profile.displaynamefu=v GrindStatus:UpdateText() end,
			order = 9006,
		},
		showpercentfu = {
			name = L["Display Percent"]..L["(fubar)"],
			desc = L["Display progress percent in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displaypercentfu end,
			set = function(v) GrindStatus.db.profile.displaypercentfu=v GrindStatus:UpdateText() end,
			order = 9008,
		},
		showtotalrepfu = {
			name = L["Display Total Rep"]..L["(fubar)"],
			desc = L["Display total rep progress in summary text."],
			type = "toggle",
			get = function() return GrindStatus.db.profile.displayabsoluterepfu end,
			set = function(v) GrindStatus.db.profile.displayabsoluterepfu=v GrindStatus:UpdateText() end,
			order = 9010,
		},
		header9 = {
			type = "header",
			order = 9999,
		},
		hideoverlay = {
			name = L["Hide Overlay"],
			desc = L["Hide the rep bar overlay"],
			type = "toggle",
			get = function() return GrindStatus.db.profile.hideoverlay end,
			set = function(v) GrindStatus.db.profile.hideoverlay=v if v then GrindStatusFrame:Hide() else GrindStatusFrame:Show() end GrindStatus:UpdateText() end,
			order = 10000,
		},
		lock = {
			name = L["Lock"],
			desc = L["Toggle Locking"],
			type = "toggle",
			get = function() return locked end,
			set = function(v) locked=v end,
			order = 10002,
		},
	}
}
GrindStatus.ToTrack = {}
local currentfaction
local currentbagitems --["itemid"] = num
local currentquestcompletion --[questnumber] = {[1] = {["got"] = numGot, ["needed"] = numNeeded}, }
local currentrep
local racemodifier
function GrindStatus:OnInitialize()
	GrindStatus:RegisterChatCommand({"/grindstatus", "/grinds"}, options)
	
	CreateFrame("Button", "GrindStatusFrame", UIParent)
	GrindStatusFrame:SetFrameStrata("HIGH")
	GrindStatusFrame:SetWidth(300)
	GrindStatusFrame:SetHeight(11)
	GrindStatusFrame:SetPoint("BOTTOM",ReputationWatchBar,"BOTTOM",0,0)
	GrindStatusFrame:EnableMouse(true)
	GrindStatusFrame:SetMovable(true)
	GrindStatusFrame:CreateFontString("GrindStatusFrameText","HIGH")
	GrindStatusFrameText:SetPoint("CENTER",GrindStatusFrame,"CENTER",0,3)
	GrindStatusFrameText:SetFontObject("GameFontHighlight")
	GrindStatusFrameText:SetTextColor(1, 1, 1)
	GrindStatusFrameText:Show()
	GrindStatusFrame:SetScript("OnMouseDown", function() if locked == false then GrindStatusFrame:StartMoving() end end)
	GrindStatusFrame:SetScript("OnMouseUp", function() GrindStatusFrame:StopMovingOrSizing() GrindStatus:LootFrame() end)
	dewdrop:Register(GrindStatusFrame,'children',function() dewdrop:FeedAceOptionsTable(GrindStatus.Options) end)
	tablet:Register(GrindStatusFrame,
		'children', GrindStatus.MakeSmallTooltip,
		'point', function()
			return "BOTTOM", "TOP"
		end
	)
	
	CreateFrame("Button", "GrindStatusDummyFrame")
	GrindStatusDummyFrame:SetWidth(1)
	GrindStatusDummyFrame:SetHeight(1)
	GrindStatusDummyFrame:SetPoint("CENTER")
	dewdrop:Register(GrindStatusDummyFrame,'children',GrindStatus.PopulateLoot)
	
	CreateFrame("GameTooltip","GrindStatusTooltip",SniffFrame,"GameTooltipTemplate")
	GrindStatusTooltip:SetWidth(1)
	GrindStatusTooltip:SetHeight(1)
	
	if GrindStatus.db.profile.displayname == nil then
		GrindStatus.db.profile.displayname = true
	end
	if GrindStatus.db.profile.displaypercent == nil then
		GrindStatus.db.profile.displaypercent = true
	end
	if GrindStatus.db.profile.displayabsoluterep == nil then
		GrindStatus.db.profile.displayabsoluterep = false
	end
	if GrindStatus.db.profile.displaynamefu == nil then
		GrindStatus.db.profile.displaynamefu = true
	end
	if GrindStatus.db.profile.displaypercentfu == nil then
		GrindStatus.db.profile.displaypercentfu = true
	end
	if GrindStatus.db.profile.displayabsoluterepfu == nil then
		GrindStatus.db.profile.displayabsoluterepfu = false
	end
	if GrindStatus.db.profile.autoswitch == nil then
		GrindStatus.db.profile.autoswitch = false
	end
	if GrindStatus.db.profile.hideoverlay == nil then
		GrindStatus.db.profile.hideoverlay = false
	end
end
function GrindStatus:OnEnable()
	GrindStatus:RegisterEvent("Quixote_Leaderboard_Update")
	GrindStatus:RegisterEvent("Quixote_Quest_Lost")
	GrindStatus:RegisterEvent("UPDATE_FACTION")
	GrindStatus:RegisterEvent("BAG_UPDATE")
	GrindStatus:RegisterEvent("GrindStatus_UpdateRepItems", GrindStatus.UpdateRepItems)
	GrindStatus:RegisterEvent("GrindStatus_RewardsRefresh")
	if GrindStatus.db.profile.autoswitch then
		GrindStatus:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	end
	if not GrindStatus.db.profile.hideoverlay then
		GrindStatusFrame:Hide()
	else
		GrindStatusFrame:Show()
	end
	ReputationWatchBar:EnableMouse(false)
	GrindStatus:FullStatusUpdate()
	if UnitRace("player") == BR["Human"] then
		racemodifier = 1.1
	else
		racemodifier = 1
	end
end
function GrindStatus:OnDisable()
	GrindStatusFrame:Hide()
	GrindStatus:UnregisterAllEvents()
	ReputationWatchBar:EnableMouse(true)
end
function GrindStatus:Quixote_Leaderboard_Update(name, qid, lbid, description, numHad, numGot, numNeeded, lbtype)
	if lbtype ~= "item" and lbtype ~= "monster" then return end
	local questnum = 0
	if GrindStatus.ToTrack[currentfaction].quests > 0 then
		for i = 1, GrindStatus.ToTrack[currentfaction].quests do
			if GrindStatus.ToTrack[currentfaction]["quest"..i] == name then
				questnum = i
			end
		end
	end
	if questnum == 0 then return end
	if currentquestcompletion[questnum] == nil then currentquestcompletion[questnum] = {} GrindStatus:GetFullQuestInfo(name) end
	currentquestcompletion[questnum][lbid] = {["got"] = numGot, ["needed"] = numNeeded}
	GrindStatus:UpdateText()
end
function GrindStatus:Quixote_Quest_Lost(name, index)
	GrindStatus:FullStatusUpdate()
end
function GrindStatus:GrindStatus_RefreshTablet()
	tablet:Refresh('GrindStatusDummy')
end
function GrindStatus:CHAT_MSG_COMBAT_FACTION_CHANGE()
	--this code based on tekAutoRep, tekkub rocks.
	if GrindStatus.db.profile.autoswitch then
		local _, faction = deformat(arg1, FACTION_STANDING_CHANGED)
		if not faction then faction = deformat(arg1, FACTION_STANDING_INCREASED) or deformat(arg1, FACTION_STANDING_DECREASED) end
		if faction then
			GrindStatus:SetWatchedFaction(faction)
		end
	end
end
function GrindStatus:UPDATE_FACTION(arg)
	local name, _, _, _, value = GetWatchedFactionInfo()
	if name ~= currentfaction then
		currentfaction = name
		GrindStatus:FullStatusUpdate()
		return
	end
	currentrep = value
	GrindStatus:UpdateText()
end
function GrindStatus:BAG_UPDATE(arg1)
	GrindStatus:ScheduleEvent("GrindStatus_UpdateRepItems", 2)
end
function GrindStatus:UpdateRepItems()
	GrindStatus:CancelAllScheduledEvents()
	if GrindStatus.ToTrack[currentfaction] and GrindStatus.ToTrack[currentfaction].items > 0 then
		for i=1, GrindStatus.ToTrack[currentfaction].items do
			currentbagitems[GrindStatus.ToTrack[currentfaction]["item"..i]] = GetItemCount(GrindStatus.ToTrack[currentfaction]["item"..i], true)
		end
	end
	GrindStatus:UpdateText()
end
function GrindStatus:SetWatchedFaction(faction)
	local current = GetWatchedFactionInfo()
	for i=1,GetNumFactions() do
		local name = GetFactionInfo(i)
		if name == faction and name ~= current then
			SetWatchedFactionIndex(i)
			return
		end
	end
end
function GrindStatus:FullStatusUpdate()
	local name, _, _, _, value = GetWatchedFactionInfo()
	currentfaction = name
	currentrep = value
	currentbagitems = {}
	currentquestcompletion = {}
	if not GrindStatus.ToTrack[currentfaction] then
		return GrindStatus:UpdateText()
	end
	if GrindStatus.ToTrack[currentfaction].quests > 0 then
		for i = 1, GrindStatus.ToTrack[currentfaction].quests do
			GrindStatus:GetFullQuestInfo(GrindStatus.ToTrack[currentfaction]["quest"..i])
		end
	end
	GrindStatus:UpdateRepItems()
	GrindStatus:UpdateText()
end
function GrindStatus:UpdateText()
	if GrindStatus.db.profile.hideoverlay then
		GrindStatusFrame:Hide()
	else
		GrindStatusFrame:Show()
	end
	if not GrindStatus.ToTrack[currentfaction] then
		GrindStatusFrameText:SetText("Unknown")
		return
	end
	GrindStatusFrame:EnableMouse(true)
	local assumedrep = currentrep
	if GrindStatus.ToTrack[currentfaction].quests > 0 then
		for i=1, GrindStatus.ToTrack[currentfaction].quests do
			local itemsdone = 0
			local itemstotal = 0
			if currentquestcompletion[i] then
				for k, v in pairs(currentquestcompletion[i]) do
					itemsdone = itemsdone + v.got
					itemstotal = itemstotal + v.needed
				end
				if GrindStatus.ToTrack[currentfaction]["quest"..i.."stop"] and GrindStatus.ToTrack[currentfaction]["quest"..i.."stop"] <= assumedrep then
					--this quest will give no faction credit.
				else
					assumedrep = assumedrep + ((itemsdone / itemstotal) * (GrindStatus.ToTrack[currentfaction]["quest"..i.."step"] * racemodifier))
					if GrindStatus.ToTrack[currentfaction]["quest"..i.."stop"] and GrindStatus.ToTrack[currentfaction]["quest"..i.."stop"] <= assumedrep then
						--we'll get credit for this quest, but it'll be partial and bring us to this quests's cap
						assumedrep = GrindStatus.ToTrack[currentfaction]["quest"..i.."stop"]
					end
				end
			end
		end
	end
	if GrindStatus.ToTrack[currentfaction].items > 0 then
		for i = 1, GrindStatus.ToTrack[currentfaction].items do
			if tonumber(currentbagitems[GrindStatus.ToTrack[currentfaction]["item"..i]]) and tonumber(GrindStatus.ToTrack[currentfaction]["item"..i.."step"]) then
				if GrindStatus.ToTrack[currentfaction]["item"..i.."stop"] and GrindStatus.ToTrack[currentfaction]["item"..i.."stop"] <= assumedrep then
					--this item will give no faction credit.
				else
					assumedrep = assumedrep + ((currentbagitems[GrindStatus.ToTrack[currentfaction]["item"..i]]) * (GrindStatus.ToTrack[currentfaction]["item"..i.."step"] * racemodifier))
					if GrindStatus.ToTrack[currentfaction]["item"..i.."stop"] and GrindStatus.ToTrack[currentfaction]["item"..i.."stop"] <= assumedrep then
						--we'll get credit for this item, but it'll be partial and bring us to this item's cap
						assumedrep = GrindStatus.ToTrack[currentfaction]["item"..i.."stop"]
					end
				end
			end
		end
	end
	local startrep
	local endrep
	if GrindStatus.db.profile[currentfaction] and GrindStatus.db.profile[currentfaction].overridestart then
		startrep = GrindStatus.db.profile[currentfaction].overridestart
	else
		startrep = GrindStatus.ToTrack[currentfaction].startrepvalue
	end
	if GrindStatus.db.profile[currentfaction] and GrindStatus.db.profile[currentfaction].overrideend then
		endrep = GrindStatus.db.profile[currentfaction].overrideend
	else
		endrep = GrindStatus.ToTrack[currentfaction].endrepvalue
	end
	if endrep == startrep then GrindStatusFrameText:SetText("0%") return end
	local text = ""
	if GrindStatus.db.profile.displayname then
		text = currentfaction
		if GrindStatus.db.profile.displaypercent or GrindStatus.db.profile.displayabsoluterep then
			text = text..": "
		end
	end
	if GrindStatus.db.profile.displaypercent then
		text = text..string.format("%.3f", 100*((assumedrep - startrep) / (endrep - startrep ))).."%"
		if GrindStatus.db.profile.displayabsoluterep then
			text = text.." - "
		end
	end
	if GrindStatus.db.profile.displayabsoluterep then
		text = text..math.floor(assumedrep).."/"..endrep
	end
	GrindStatusFrameText:SetText(text)
	
	futext = ""
	if GrindStatus.db.profile.displaynamefu then
		futext = currentfaction
		if GrindStatus.db.profile.displaypercentfu or GrindStatus.db.profile.displayabsoluterepfu then
			futext = futext..": "
		end
	end
	if GrindStatus.db.profile.displaypercentfu then
		futext = futext..string.format("%.3f", 100*((assumedrep - startrep) / (endrep - startrep ))).."%"
		if GrindStatus.db.profile.displayabsoluterepfu then
			futext = futext.." - "
		end
	end
	if GrindStatus.db.profile.displayabsoluterepfu then
		if assumedrep > 42999 then
			futext = futext.."42999".."/"..endrep
		else
			futext = futext..math.floor(assumedrep).."/"..endrep
		end
	end
	GrindStatusFu:Update()
end
function GrindStatus:GetFullQuestInfo(name)
	local _, _, _, _, _, objectives, _, id = quixote:GetQuest(name)
	if GrindStatus.ToTrack[currentfaction].quests > 0 then
		for i = 1, GrindStatus.ToTrack[currentfaction].quests do
			if GrindStatus.ToTrack[currentfaction]["quest"..i] == name then
				questnum = i
			end
		end
	end
	if objectives then
		currentquestcompletion[questnum] = {}
		for j = 1, objectives do
			local description, obtype, numGot, numNeeded = quixote:GetQuestStatusById(id, j)
			if obtype == "item" or obtype == "monster" then
				currentquestcompletion[questnum][j] = {["got"] = numGot, ["needed"] = numNeeded}
			end
		end
	end
end
function GrindStatus:MakeSmallTooltip(faction)
	local usefaction
	if faction then
		usefaction = faction
	else
		usefaction = currentfaction
	end
	
	tablet:SetTitle(usefaction)
	local cat = tablet:AddCategory('columns', 2)
	if not usefaction then
		cat:AddLine('text', L["No faction selected"])
		return
	end
	if not GrindStatus.ToTrack[usefaction] then
		tablet:Close()
	end
	local assumedrep, repstring, nextrepvalue, bottom
	for i=1,GetNumFactions() do
		local name, _, standing, bot, top, earnedValue = GetFactionInfo(i)
		if name == usefaction then
			assumedrep = earnedValue
			repstring = getglobal("FACTION_STANDING_LABEL"..standing)
			nextrepvalue = top-bot
			bottom = bot
		end
	end
	cat:AddLine('text', repstring, 'text2', assumedrep-bottom.."/"..nextrepvalue, 'textR', 0, 'textG', 1, 'textB', 0, 'text2R', 0, 'text2G', 1, 'text2B', 0)
	if GrindStatus.ToTrack[usefaction].quests > 0 then
		for i=1, GrindStatus.ToTrack[usefaction].quests do
			local _, _, _, _, _, objectives, _, id = quixote:GetQuest(GrindStatus.ToTrack[usefaction]["quest"..i])
			if objectives then
				local numdone = 0
				local numneeded = 0
				for j = 1, objectives do
					local description, obtype, numGot, numNeeded = quixote:GetQuestStatusById(id, j)
					if obtype == "item" or obtype == "monster" then
						numdone = numdone + numGot
						numneeded = numneeded + numNeeded
					end
				end
				if numdone and numdone > 0 then
					if GrindStatus.ToTrack[usefaction]["quest"..i.."stop"] and GrindStatus.ToTrack[usefaction]["quest"..i.."stop"] <= assumedrep then
						--this quest will give no faction credit.
					else
						local addedrep = ((numdone / numneeded) * (GrindStatus.ToTrack[usefaction]["quest"..i.."step"] * racemodifier))
						assumedrep = assumedrep + addedrep
						if GrindStatus.ToTrack[usefaction]["quest"..i.."stop"] and GrindStatus.ToTrack[usefaction]["quest"..i.."stop"] <= assumedrep then
							addedrep = GrindStatus.ToTrack[usefaction]["quest"..i.."stop"] - assumedrep
							assumedrep = GrindStatus.ToTrack[usefaction]["quest"..i.."stop"]
						end
						cat:AddLine('text', GrindStatus.ToTrack[usefaction]["quest"..i], 'text2', (math.floor((numdone/numneeded)*100).."% ("..string.format("%.2f", addedrep)..")"), 'textR', 1, 'textG', 0.4, 'textB', 0, 'text2R', 1, 'text2G', 0.4, 'text2B', 0)
					end
				end
			end
		end
	end
	if GrindStatus.ToTrack[usefaction].items > 0 then
		for i = 1, GrindStatus.ToTrack[usefaction].items do
			if GrindStatus.ToTrack[usefaction]["item"..i.."stop"] and GrindStatus.ToTrack[usefaction]["item"..i.."stop"] <= assumedrep then
				--this item will give no faction credit.
			else
				local count  = GetItemCount(GrindStatus.ToTrack[usefaction]["item"..i], true)
				local addedrep = count * (GrindStatus.ToTrack[usefaction]["item"..i.."step"] * racemodifier)
				assumedrep = assumedrep + addedrep
				if GrindStatus.ToTrack[usefaction]["item"..i.."stop"] and GrindStatus.ToTrack[usefaction]["item"..i.."stop"] <= assumedrep then
					addedrep = GrindStatus.ToTrack[usefaction]["item"..i.."stop"] - assumedrep
					assumedrep = GrindStatus.ToTrack[usefaction]["item"..i.."stop"]
				end
				local name = GetItemInfo(GrindStatus.ToTrack[usefaction]["item"..i])
				if name and count>0 then
					cat:AddLine('text', name, 'text2', (count.." ("..string.format("%.2f", addedrep)..")"), 'textR', 0.5, 'textG', 0.5, 'textB', 1, 'text2R', 0.5, 'text2G', 0.5, 'text2B', 1)
				end
			end
		end
	end
	local startrep
	local endrep
	if GrindStatus.db.profile[usefaction] and GrindStatus.db.profile[usefaction].overridestart then
		startrep = GrindStatus.db.profile[usefaction].overridestart
	else
		startrep = GrindStatus.ToTrack[usefaction].startrepvalue
	end
	if GrindStatus.db.profile[usefaction] and GrindStatus.db.profile[usefaction].overrideend then
		endrep = GrindStatus.db.profile[usefaction].overrideend
	else
		endrep = GrindStatus.ToTrack[usefaction].endrepvalue
	end
	if endrep == startrep then tablet:Close() return end
	cat:AddLine('text', L["Grind Start"], 'text2', startrep, 'textR', 0.5, 'textG', 0.5, 'textB', 0.5, 'text2R', 0.5, 'text2G', 0.5, 'text2B', 0.5)
	cat:AddLine('text', L["Grind End"], 'text2', endrep, 'textR', 0.5, 'textG', 0.5, 'textB', 0.5, 'text2R', 0.5, 'text2G', 0.5, 'text2B', 0.5)
	if assumedrep > 42999 then
		cat:AddLine('text', L["Total"], 'text2', "42999", 'textR', 1, 'textG', 1, 'textB', 0, 'text2R', 1, 'text2G', 1, 'text2B', 0)
	else
		cat:AddLine('text', L["Total"], 'text2', assumedrep, 'textR', 1, 'textG', 1, 'textB', 0, 'text2R', 1, 'text2G', 1, 'text2B', 0)
	end
	cat:AddLine('text', L["Percent to Goal"], 'text2',string.format("%.3f", 100*((assumedrep - startrep) / (endrep - startrep ))).."%", 'textR', 1, 'textG', 1, 'textB', 0, 'text2R', 1, 'text2G', 1, 'text2B', 0)
	
	tablet:SetHint(L["Left click to show faction rewards. Right click for Options."])
end
function GrindStatus:LootFrame(faction)
	if not faction then faction = currentfaction end
	lootfaction = faction
	local x, y = GetCursorPosition()
	GrindStatusDummyFrame:ClearAllPoints()
	GrindStatusDummyFrame:SetPoint("BOTTOMLEFT",x,y)
	dewdrop:Open(GrindStatusDummyFrame)
end
function GrindStatus:PopulateLoot()
	if not lootfaction then
		return
	end
	local rewardstable = PT:GetSetTable("Rewards - "..GrindStatus.ToTrack[lootfaction].english)
	if not rewardstable then
		return dewdrop:Close()
	end
	dewdrop:AddLine(
		'text', lootfaction,
		'isTitle', true
	)
	local displaykeys = {}
	local displaytable = {}
	for k,v in pairs(rewardstable) do
		if not displaytable[v] then
			displaytable[v] = {}
			table.insert(displaykeys, v)
		end
		table.insert(displaytable[v], k)
	end
	table.sort(displaykeys)
	for k,v in pairs(displaykeys) do
		dewdrop:AddLine(
			'text', GrindStatus:NumberToGoalText(v),
			'isTitle', true,
			'order', k*100
		)
		for a,b in pairs(displaytable[v]) do
			local name, link, rarity, _,_,_,_,_,_, texture = GetItemInfo(tonumber(b))
			if not link then
				dewdrop:AddLine(
					'text', "|cFFFF2222["..b.."]",
					'func', GrindStatus.RewardClick,
					'arg1', self, 'arg2', b,
					'tooltipTitle', "|cFFFF2222"..b,
					'tooltipText', L["Query_Warning"],
					'order', k*100+1
				)
			else
				dewdrop:AddLine(
					'text', qualitycolors[rarity].."["..name.."]",
					'func', GrindStatus.RewardClick,
					'arg1', self, 'arg2', b,
					'tooltipFunc', GrindStatus.SetTooltip,
					'tooltipArg1', GameTooltip, 'tooltipArg2', b,
					'order', k*100+1,
					'icon', texture
				)
			end
		end
	end
end
function GrindStatus:SetTooltip(arg1)
	GameTooltip_SetDefaultAnchor(GameTooltip, this)
	GameTooltip:SetHyperlink("item:"..arg1..":0:0:0:0:0:0:0")
end
function GrindStatus:RewardClick(id)
	local name, link, rarity, _,_,_,_,_,_, texture = GetItemInfo(id)
	if not name then
		GrindStatus:GetItemData(id)
		GrindStatus:ScheduleEvent("GrindStatus_RewardsRefresh", 2)
		return
	end
	if IsControlKeyDown() then
		DressUpItem(id)
	else
		if not ChatFrameEditBox:IsVisible() then
			ChatFrameEditBox:Show()
		end
		local _, link = GetItemInfo("item:"..id)
		ChatFrameEditBox:Insert(link)
	end
end
function GrindStatus:GrindStatus_RewardsRefresh()
	dewdrop:Refresh(1)
end
function GrindStatus:GetItemData(id)
	GrindStatusTooltip:SetOwner(this, "ANCHOR_PRESERVE")
	GrindStatusTooltip:SetHyperlink("item:" .. id)
	GrindStatusTooltip:Hide()
end
function GrindStatus:RegisterGroupOrder(group, catorder)
	grouporder[catorder] = string.gsub(group, " ", "")
	GrindStatus.Options.args[grouporder[catorder]] = {
		name = group,
		desc = group,
		type = "group",
		order = catorder,
		args = {},
	}
end
function GrindStatus:InitPlugin(factionname, pluginname, pluginorder, pluginplayergroup)
	if pluginplayergroup then
		local playergroup = UnitFactionGroup("player")
		if playergroup ~= pluginplayergroup then
			return GrindStatus:ToggleModuleActive(pluginname, false)
		end
	end
	local factionopts = {
		name = factionname,
		desc = factionname,
		type = "group",
		args = {
			toggle = {
				name = L["Enable"],
				desc = L["Toggle the module on and off."],
				type = "toggle",
				get = function() return GrindStatus:IsModuleActive(pluginname) end,
				set = function() GrindStatus.db.profile[factionname].active = GrindStatus:ToggleModuleActive(pluginname) GrindStatus:FullStatusUpdate() end,
				order = 1,
			},
			overridestart = {
				name = L["Grind Start"],
				desc = L["Grind Start"],
				type = 'text',
				get = function()
					if GrindStatus.db.profile[factionname].overridestart then
						return GrindStatus:NumberToGoalText(GrindStatus.db.profile[factionname].overridestart)
					elseif not tonumber(GrindStatus:NumberToGoalText(GrindStatus.ToTrack[factionname].startrepvalue)) then
						return GrindStatus:NumberToGoalText(GrindStatus.ToTrack[factionname].startrepvalue)
					else
						return L["Default"]
					end
				end,
				set = function(v)
					if v == L["Default"] then
						GrindStatus.db.profile[factionname].overridestart = nil
					elseif v == L["Hated"] then
						GrindStatus.db.profile[factionname].overridestart = -42000
					elseif v == L["Hostile"] then
						GrindStatus.db.profile[factionname].overridestart = -6000
					elseif v == L["Unfriendly"] then
						GrindStatus.db.profile[factionname].overridestart = -3000
					elseif v == L["Neutral"] then
						GrindStatus.db.profile[factionname].overridestart = 0
					elseif v == L["Friendly"] then
						GrindStatus.db.profile[factionname].overridestart = 3000
					elseif v == L["Honored"] then
						GrindStatus.db.profile[factionname].overridestart = 9000
					elseif v == L["Revered"] then
						GrindStatus.db.profile[factionname].overridestart = 21000
					elseif v == L["Exalted"] then
						GrindStatus.db.profile[factionname].overridestart = 42000
					elseif v == L["Max Exalted"] then
						GrindStatus.db.profile[factionname].overridestart = 42999
					elseif v == L["Current"] then
						for i=1,GetNumFactions() do
							local name, _, _, _, _, earnedValue = GetFactionInfo(i)
							if name == factionname then 
								GrindStatus.db.profile[factionname].overridestart = earnedValue
							end
						end
					end
					if GrindStatus.db.profile[factionname].overridestart == GrindStatus.ToTrack[factionname].startrepvalue then
						GrindStatus.db.profile[factionname].overridestart = nil
					end
					GrindStatus:FullStatusUpdate()
				end,
				validate = {L["Default"], L["Hated"], L["Hostile"], L["Unfriendly"], L["Neutral"], L["Friendly"], 
					L["Honored"], L["Revered"], L["Exalted"], L["Max Exalted"], L["Current"]},
				order = 100,
			},
			overrideend = {
				name = L["Grind End"],
				desc = L["Grind End"],
				type = 'text',
				get = function()
					if GrindStatus.db.profile[factionname].overrideend then
						return GrindStatus:NumberToGoalText(GrindStatus.db.profile[factionname].overrideend)
					elseif not tonumber(GrindStatus:NumberToGoalText(GrindStatus.ToTrack[factionname].endrepvalue)) then
						return GrindStatus:NumberToGoalText(GrindStatus.ToTrack[factionname].endrepvalue)
					else
						return L["Default"]
					end
				end,
				set = function(v)
					if v == L["Default"] then
						GrindStatus.db.profile[factionname].overrideend = nil
					elseif v == L["Hated"] then
						GrindStatus.db.profile[factionname].overrideend = -42000
					elseif v == L["Hostile"] then
						GrindStatus.db.profile[factionname].overrideend = -6000
					elseif v == L["Unfriendly"] then
						GrindStatus.db.profile[factionname].overrideend = -3000
					elseif v == L["Neutral"] then
						GrindStatus.db.profile[factionname].overrideend = 0
					elseif v == L["Friendly"] then
						GrindStatus.db.profile[factionname].overrideend = 3000
					elseif v == L["Honored"] then
						GrindStatus.db.profile[factionname].overrideend = 9000
					elseif v == L["Revered"] then
						GrindStatus.db.profile[factionname].overrideend = 21000
					elseif v == L["Exalted"] then
						GrindStatus.db.profile[factionname].overrideend = 42000
					elseif v == L["Max Exalted"] then
						GrindStatus.db.profile[factionname].overrideend = 42999
					end
					if GrindStatus.db.profile[factionname].overrideend == GrindStatus.ToTrack[factionname].endrepvalue then
						GrindStatus.db.profile[factionname].overrideend = nil
					end
					GrindStatus:FullStatusUpdate()
				end,
				validate = {L["Default"], L["Hated"], L["Hostile"], L["Unfriendly"], L["Neutral"], L["Friendly"], 
					L["Honored"], L["Revered"], L["Exalted"], L["Max Exalted"]},
				order = 101,
			},
			blank = {
				type = "header",
				order = 200,
			},
			watch = {
				type = 'execute',
				name = L["Focus"],
				desc = L["Set this faction as the exp bar."],
				func = function()
					GrindStatus:SetWatchedFaction(factionname)
				end,
				order = 201,
			},
			showrewards = {
				type = 'execute',
				name = L["Show Rewards"],
				desc = L["Show this faction's rewards."],
				func = function()
					GrindStatus:LootFrame(factionname)
				end,
				order = 202,
			},
		}
	}
	GrindStatus.Options.args[grouporder[pluginorder]].args[pluginname] = factionopts
	GrindStatus.Options.args.alphabetical.args[pluginname] = factionopts
	if GrindStatus.db.profile[factionname] == nil then
		GrindStatus.db.profile[factionname] = {}
	end
	if GrindStatus.db.profile[factionname].active == nil then
		GrindStatus.db.profile[factionname].active = true
	end
	GrindStatus:ToggleModuleActive(pluginname, GrindStatus.db.profile[factionname].active)
end
function GrindStatus:NumberToGoalText(num)
	if num == -42000 or num == 1 then
		return L["Hated"]
	elseif num == -6000 or num == 2 then
		return L["Hostile"]
	elseif num == -3000 or num == 3 then
		return L["Unfriendly"]
	elseif num == 0 or num == 4 then
		return L["Neutral"]
	elseif num == 3000 or num == 5 then
		return L["Friendly"]
	elseif num == 9000 or num == 6 then
		return L["Honored"]
	elseif num == 21000 or num == 7 then
		return L["Revered"]
	elseif num == 42000 or num == 8 then
		return L["Exalted"]
	elseif num == 42999 or num == 9 then
		return L["Max Exalted"]
	end
	return num
end
--FuBar
GrindStatusFu = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "FuBarPlugin-2.0")
GrindStatusFu:RegisterDB("GrindStatusDB")
function GrindStatusFu:OnInitialize()
	
end
function GrindStatusFu:OnMenuRequest()
	dewdrop:FeedAceOptionsTable(GrindStatus.Options)
end
function GrindStatusFu:OnTextUpdate()
	self:SetText(futext)
end
function GrindStatusFu:OnEnable()
	
end
function GrindStatusFu:OnTooltipUpdate()
	GrindStatus:MakeSmallTooltip()
end
function GrindStatusFu:OnClick()
	GrindStatus:LootFrame()
end